
#include <stdio.h>
#include "xlhtml.h"
#include "support.h"

extern int Xtract;
extern int xp;
extern int sheet_count;
extern int xr1 ;
extern int xr2 ;
extern int xc1 ;
extern int xc2 ;
extern int Ascii;

		
		
void
SetupExtraction (void)
{
  if (Xtract)
    {				/* Revise the page settings... */
/*		printf("-%d %d %d %d %d<br>\n", xp, xr1, xr2, xc1, xc2); */
      if ((xp >= first_sheet) && (xp <= last_sheet) && (xp <= sheet_count))
	{
	  first_sheet = xp;
	  last_sheet = xp;
	  if (xr1 < 0)
	    {
	      xr1 = (S16) ws_array[xp]->first_row;
	      xr2 = (S16) ws_array[xp]->biggest_row;
	    }
	  else if ((xr1 >= ws_array[xp]->first_row)
		   && (xr1 <= ws_array[xp]->biggest_row)
		   && (xr2 >= ws_array[xp]->first_row)
		   && (xr2 <= ws_array[xp]->biggest_row))
	    {
	      ws_array[xp]->first_row = xr1;
	      ws_array[xp]->biggest_row = xr2;
	    }
	  else
	    {
	      if (Ascii)
		fprintf (stderr, "Error - Row not in range during extraction"
			 " (%d or %d not in [%ld..%ld])\n", xr1, xr2,
			 (long) ws_array[xp]->first_row,
			 (long) ws_array[xp]->biggest_row);
	      else
		{
		  printf ("Error - Row not in range during extraction.");
		  output_footer ();
		}
	      return;
	    }

	  if (xc1 < 0)
	    {
	      xc1 = ws_array[xp]->first_col;
	      xc2 = ws_array[xp]->biggest_col;
	    }
	  else if ((xc1 >= ws_array[xp]->first_col)
		   && (xc1 <= ws_array[xp]->biggest_col)
		   && (xc2 >= ws_array[xp]->first_col)
		   && (xc2 <= ws_array[xp]->biggest_col))
	    {
	      ws_array[xp]->first_col = xc1;
	      ws_array[xp]->biggest_col = xc2;
	    }
	  else
	    {
	      if (Ascii)
		fprintf (stderr, "Error - Col not in range during extraction"
			 " (%d or %d not in [%d..%d])\n", xc1, xc2,
			 ws_array[xp]->first_col, ws_array[xp]->biggest_col);
	      else
		{
		  printf ("Error - Col not in range during extraction.\n");
		  output_footer ();
		}
	      return;
	    }
	}
      else
	{
	  if (Ascii)
	    fprintf (stderr, "Error - Page not in range during extraction.");
	  else
	    {
	      printf ("Error - Page not in range during extraction.");
	      output_footer ();
	    }
	  return;
	}
    }
}
